unofficial mirror of libc-alpha@sourceware.org
 help / color / mirror / Atom feed
From: Florian Weimer <fweimer@redhat.com>
To: libc-alpha@sourceware.org
Subject: [PATCH v2] elf: Add ld.so test with non-existing program name
Date: Mon, 08 Apr 2024 18:42:20 +0200	[thread overview]
Message-ID: <877ch7vmab.fsf@oldenburg.str.redhat.com> (raw)

None of the existing tests seem to cover the case where
_dl_signal_error is called without an active error handler.
The new elf/tst-rtld-does-not-exist test triggers such a
_dl_signal_error call from _dl_map_object.

---
v2: Delete temporary file.

 elf/Makefile                   |  7 +++++++
 elf/tst-rtld-does-not-exist.sh | 39 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 46 insertions(+)

diff --git a/elf/Makefile b/elf/Makefile
index 4f1903391a..6dad11bcfb 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -621,6 +621,13 @@ $(objpfx)tst-valgrind-smoke.out: tst-valgrind-smoke.sh $(objpfx)ld.so $(objpfx)v
 		'$(run-program-env)' '$(rpath-link)' $(objpfx)valgrind-test \
 		'$(valgrind-suppressions-tst-valgrind-smoke)' > $@; $(evaluate-test)
 
+ifeq ($(run-built-tests),yes)
+tests-special += $(objpfx)tst-rtld-does-not-exist.out
+endif
+$(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
+	$(SHELL) $< $(objpfx)ld.so > $@; \
+	$(evaluate-test)
+
 tests += $(tests-execstack-$(have-z-execstack))
 ifeq ($(run-built-tests),yes)
 tests-special += \
diff --git a/elf/tst-rtld-does-not-exist.sh b/elf/tst-rtld-does-not-exist.sh
new file mode 100644
index 0000000000..a4a781ccfd
--- /dev/null
+++ b/elf/tst-rtld-does-not-exist.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+# Check that running ld.so with a non-existing file prints an error.
+# Copyright (C) 2024 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+export LC_ALL=C
+
+rtld="$1"
+tmp_out="$(mktemp)"
+
+$rtld program-does-not-exist 2>"$tmp_out"
+status=$?
+echo "$rtld exit status: $status"
+echo "output (with expected error):"
+cat "$tmp_out"
+
+if test $status -eq 127 \
+	&& grep -q "^program-does-not-exist: error while loading shared libraries: program-does-not-exist: cannot open shared object file$" "$tmp_out" \
+	&& test "$(wc -l < "$tmp_out")" -eq 1 ; then
+    status=0
+else
+    status=1
+fi
+rm "$tmp_out"
+exit $status

base-commit: f8d8b1b1e6d3b8b93f224efc796b7ea083fdb83f


             reply	other threads:[~2024-04-08 16:43 UTC|newest]

Thread overview: 4+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-04-08 16:42 Florian Weimer [this message]
2024-04-08 16:45 ` [PATCH v2] elf: Add ld.so test with non-existing program name H.J. Lu
2024-04-08 16:48   ` Florian Weimer
2024-04-08 16:58 ` H.J. Lu

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://www.gnu.org/software/libc/involved.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=877ch7vmab.fsf@oldenburg.str.redhat.com \
    --to=fweimer@redhat.com \
    --cc=libc-alpha@sourceware.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).